format longG
clear; clc; clf; close all;
x = load('Lerelva\Tog5.txt');
v = 20.6;
AxelSpacingTrue = [2.500 14.000 2.500 5.125 2.550 13.975 2.500];
% AxelSpacingTrue = flip(AxelSpacingTrue);
S = 2;
mps = 1024;
t = 1:size(x);
filtervalue = 4e-5;
strain = [ x(:,1)- mean(x(1:500,1)), x(:,2)- mean(x(1:500,2)) x(:,3)- mean(x(1:500,3))];
figure();
set(gcf, 'position',[100 100 780 440])
% subplot(2,2,1);
plot(t,strain(:,1),t,strain(:,2),t,strain(:,3));
legend('Midt','Mot Trondheim','Mot Heimdal');
% xlim([500 4500]);
xlabel('Tid (1024 per sekund)')
ylabel('{\sigma}','rotation',0)

%filter
cutoff = 50;
sliceSpeed = 28;
sliceAxel = 28;
scale = sliceAxel:sliceAxel;

[strainFilteteredButter] = filterStrain(strain, mps, cutoff);

figure();
plot(strainFilteteredButter);
title('Strains filtered by Butter');
xlabel('x [s]');

% [strainFilteteredWaveSpeed, waveletSurface] = wavelet(strainFilteteredButter,scale,sliceSpeed);
[strainFilteteredWaveAxel, waveletSurface] = wavelet(strain,scale,sliceAxel);

figure();
plot(strainFilteteredWaveAxel(:,1));
title(['Strain Filtered by Wavelet for slice ' num2str(sliceAxel)]);

% %%speed
[vcor] = speed2(strainFilteteredWaveSpeed, 2, 3, mps, S);

%Axel Spacing
axelSpacingCalc = axelSpacing(strainFilteteredWaveAxel, 1, mps, v);

axelDifference = round((axelSpacingCalc-AxelSpacingTrue)*1000)
axelDifferenceTotalt = sum(axelDifference)
axelDifferencePercent = round(axelSpacingCalc./AxelSpacingTrue*100-100)
axelDifferenceClosestonall = sum(abs(axelDifference));
cta = sum(abs(axelDifference))


% %%Weights
% %%InfluenceLine
% I = load('IL20.txt');
% I = [I(:,1)]./max(I(:,1));
% figure();
% plot(I(:,1))
% hold on
% plot(strain(:,1))
% lengthM=5000;
% M = influenceOrdinatesMatrix(I, vcor, mps, lengthM, axelSpacingCalc, 800);
% A=(inv(transpose(M(:,:,1,1))*M(:,:,1,1))+0.001.*eye(size(M,2)))*(transpose(M(:,:,1,1))*strainFilteteredButter(:,1));
% A=transpose(A)
% strain(:,1) = M(:,:,1,1)*transpose(A);
% % figure()
% % plot(strain(:,1))