function [fstrain] = filterStrain(strain, fs, cutoff)
    Wn = cutoff / (fs / 2);
    [b, a] = butter(2, Wn, 'low');
%     freqz(b, a, 5000, fs)
    fstrain = zeros(size(strain));
        for i=1:size(fstrain,2)
            fstrain(:,i) = filtfilt(b, a, strain(:,i));
        end
end