function [strainfilt, wavelet] = wavelet(strain, scale, slice)
    wavelet = zeros(length(scale),length(strain),1,size(strain,2));
    strainfilt = zeros(size(strain));
        for i=1:size(strain,2);
            wavelet(scale,:,1,i) = cwt(strain(:,i),scale,'mexh');
            strainfilt(:,i,1,1) = wavelet(slice,:,1,i);
        end
end